<?php
$title="Firmware Update";
// show the license only if a license server is defined in the branding (or that there is no player license)
$branding_file="/usr/share/resources/default/interface/branding.php";
if (file_exists($branding_file) ) 
	include $branding_file;
	
if ( (isset($registration) && $registration!="") ) $tabs=array("Firmware","Licenses");

include ("prolog.php");

$updaterfile='/etc/updater.conf';
$defaults_updaterfile='/usr/share/resources/default/updater/defaults.conf';
if (isset($_POST['reset'])){
	exec("/etc/spinetix/config.d/updater reset",$dummy,$ret);
	if ($ret!=0) echo "Cannot reset the update configuration<br/>";
}

$updateuri='';
$defdoc = new DOMDocument;
if ( $defdoc->load($defaults_updaterfile) ) {
	$xp = new DOMXPath($defdoc);
	$nl = $xp->query("repository[@id='base']/location/@href");
	if ($nl->length) {
	     $updateuri = $nl->item(0)->value;
	}
}
if ( ! $updateuri ) {
     echo "<p style='color:red'>Missing server URI in defaults updater file.</p>\n";
}

$conf=file_get_contents($updaterfile);
if ($conf) {

	if (isset($_POST['updater']) && isset($_POST['updateuri']))
	     $new_updateuri = $_POST['updater'];
	else
	     $new_updateuri = false;

	$domdoc = new DOMDocument;
	$domdoc->preserveWhiteSpace = false;
	$domdoc->formatOutput = true;
	$domdoc->loadXML($conf);
	$xp = new DOMXPath($domdoc);

	// backwards compat with old default repository id
	$nl = $xp->query("repository[@id='hmp100']/location/@href");
	if ($nl->length) { 
	     $nlid = $xp->query("repository[@id='hmp100']/@id");
	     if ($nlid->length)
		  $nlid->item(0)->value = 'base'; // change old to new
	}

	$nl = $xp->query("repository[@id='base']/location/@href");

	if ($nl->length) {
	     if ( $new_updateuri )
		  $nl->item(0)->value = $new_updateuri;
	     $updateuri = $nl->item(0)->value;
	} else if ( $new_updateuri ) {
	     $nl = $xp->query("*[@id='base']");
	     if ($nl->length) {
		  echo "<p style='color:red'>Found incomplete base repository definitions, removing.</p>\n";
		  foreach ( $nl as $n )
		       $n->parentNode->removeChild($n);
	     }
	     $repo = $domdoc->createElement('repository');
	     $repo->setAttribute('id', 'base');
	     $loc = $domdoc->createElement('location');
	     $loc->setAttribute('href', $new_updateuri);
	     $name = $domdoc->createElement('name',
					    'User updates');
	     $main = $domdoc->getElementsByTagName('updater');
	     if ($main->length) {
		  $main = $main->item(0);
		  $main->appendChild($repo);
		  $repo->appendChild($loc);
		  $repo->appendChild($name);
		  $updateuri = $new_updateuri;
	     } else {
		  echo "<p style='color:red'>Invalid updater configuration file, cannot save modifications.</p>\n";
		  $new_updateuri = false;
	     }
	}
	if ( $new_updateuri )
	     save_file($updaterfile, $domdoc->saveXML());	
}

$timefile="/etc/cron.d/updater";

if ( isset($_POST['updateauto']) ){
	if (!isset($_POST['time']))
		$time=-1;
	else
		$time = $_POST['time'];
	$content="PATH=/usr/bin:/bin:/usr/sbin:/sbin\n";
	if ($time==-1){
		$content.="#0 -1 * * * root /usr/sbin/updater\n";
	}else if ($time>=0 && $time<24){
		$content.="0 $time * * * root /usr/sbin/updater\n";
	}else {
	     echo "Non supported time '", htmlentities($time), "' no set<br/> ";
	}
	save_file($timefile, $content);	
}else{
	$conf=file_get_contents($timefile);
	if (!$conf || $conf=="")
		$time=-1;
	elseif (preg_match("@^\s*(\d+)\s+(\d+).*/usr/sbin/updater@m",$conf,$matches))
		$time=$matches[2];
	else 
		$time=-1;
}

$reboot = false;
if (isset($_POST['license_add'])){
	//license_key
	$key = $_POST['license_key'];
	if ( preg_match("/[0-9A-Z]{5}-[0-9A-Z]{5}-[0-9A-Z]{5}-[0-9A-Z]{5}-[0-9A-Z]{5}/", $key) ) {
		$mac = getMAC();
		$mac = strtolower($mac);
		$license = file_get_contents($registration."?mac=$mac&key=$key");
		if ($license===false){
			echo "<p style='color:red'>Cannot contact license server</p><br/>";
		}elseif  (substr($license,0,1)=="-") {
			// error returned
			echo "<p style='color:red'>License server returned: ".htmlentities(substr($license,1))."</p><br/>";
		} else {
			// new license, we need to add it to the default file
			$lic = file_get_contents("/etc/spinetix/licenses");
			file_put_contents("/etc/spinetix/licenses", $license."\n".$lic);
			$reboot = true;
		}
	} else {
		echo "<p style='color:red'>License key format is not valid: ".htmlentities($key)."</p><br/>";
	}
}
if (isset($_POST['license_get'])){
	$mac = getMAC();
	$mac = strtolower($mac);
	$license = file_get_contents($registration."?mac=$mac");
	if ($license===false){
		echo "<p style='color:red'>Cannot contact license server</p><br/>";
	}elseif (substr($license,0,1)=="-") {
		// error returned
		echo "<p style='color:red'>License server returned: ".htmlentities(substr($license,1))."</p><br/>";
	} else {
		// all license are added to the default file
		file_put_contents("/etc/spinetix/licenses", $license);
		$reboot = true;
	}
}
if (isset($_POST['license_file'])){
	//new_license_file
	if (array_key_exists("new_license_file",$_FILES)){
		if ($_FILES["new_license_file"]["error"]>0 && $_FILES["new_license_file"]["name"]){
		     echo "<p style='color:red'>" . htmlspecialchars($_FILES["new_file"]["error"]) ." while uploading: ". htmlspecialchars($_FILES["new_file"]["name"]) ."</p>";
		}else {
			$lic = file_get_contents("/etc/spinetix/licenses");
			$new_license = file_get_contents($_FILES["new_license_file"]["tmp_name"]);
			file_put_contents("/etc/spinetix/licenses", $new_license."\n".$lic);
		}
	} else {
		echo "<p style='color:red'>No file selected, or file upload error</p><br/>";
	}
	$reboot = true;
}
if (isset($_POST['license_clear'])){
	unlink("/etc/spinetix/licenses");
	$reboot = true;
}
if ( $reboot ) {
	echo "Player must be restarted to activate the new licenses</p><br/>";
	shutdown("license file modified");
} else {
$nbUpdates=0;
$status=-1;
$updater_fallback=FALSE; // if only the updater is updated
$update_info=array();

function checkUpdateInfo($line) {
     global $update_info;
     global $updater_fallback;
     if (preg_match("/---\s+(FIRMWARE|UPDATER)\s+([^-]+)-([^-]+)\s+---$/",
		    $line, $matches)) {
	  $update_info['type'] = $matches[1];
	  $update_info['ver'] = $matches[2];
	  $update_info['rel'] = $matches[3];
     } elseif (preg_match("/---\s+RETRY UPDATER ONLY\s+---$/", $line)) {
	  $updater_fallback = TRUE;
     }
}

if ( isset($_POST['checkupdate']) ) {
	
	echo "<h2>Checking for Updates</h2>";
	echo "This operation might take some time.".str_repeat(' ',256)."<br/>\n";
	ob_flush();flush();
	
	$cmd='/usr/sbin/updater --log-to-stderr --lock-timeout=-1';
	$doUpdate=true;
	if ($_POST['source']=='default') $cmd .=' --max-wait-time=-1';
	else {
		$cmd .=' --repo=local-usb';
		// check for the presence of the key 
		$mount=file_get_contents("/proc/mounts");
		$mounts=explode("\n",$mount);
		$usbContent=false;
		$usbUpdate=false;
		foreach ($mounts as $mount){
			$info=preg_split("/\s/",$mount);
			if (count($info)>2){
				if ($info[1]=='/srv/raperca/content') $usbContent=true;
				if ($info[1]=='/media/usb1') $usbUpdate=true;
			}
		}
		if (!$usbUpdate){
			if ($usbContent) echo "<br/>USB storage is used as Local Storage.<br/>Please disable it using the <a href='playerconfig.php'>Media Source</a> page before doing the update.<br/>";
			else echo "<br/>No USB storage Found.<br/>";
			$doUpdate=false;
		}elseif (!file_exists("/media/usb1/updates")){
			echo "<br/>USB storage found but folder <strong>/updates</strong> doesn't exist.<br/>";
			$doUpdate=false;
		}
		
	}
	
	$cmd .=' -n';
	if ($doUpdate) {
	     $fd_desc = array(
		  0 => array("file", "/dev/null", "r"), // no stdin
		  1 => array("pipe", "w"), // read from stdout
		  2 => array("file", "/dev/null", "w"), // discard stderr
		  );
	     $updater_proc = proc_open('exec '.$cmd.' 2>&1', $fd_desc, $updater_pipes);
	     if (is_resource($updater_proc)) {
		  echo "<h3>Update log</h3>\n";
		  echo "<div class='logs'>\n";
		  while(!feof($updater_pipes[1])) {
		       $line = fgets($updater_pipes[1]);
		       if (strstr($line,"UPDATE(S) ---")){
			    $vals=explode(" ",$line);
			    if (count($vals)>3) $nbUpdates=$vals[2];
		       }
		       checkUpdateInfo($line);
		       echo htmlentities($line)."<br/>\n";
		       ob_flush();flush();
		  }
		  echo "</div>\n";
		  fclose($updater_pipes[1]);
		  $status = proc_close($updater_proc);
	     }
	     if ($status==0) {
		  if ($nbUpdates==0){
		       echo "<h3>No updates available</h3>";
		  } else {
		       echo "<h3>", htmlspecialchars($nbUpdates), " updates available</h3>\n";
		       echo "<p>";
		       if ($update_info['type'] == 'FIRMWARE') {
			    echo "Updating now would install firmware version " .
				 htmlspecialchars($update_info['ver']) .
				 " (build " . htmlspecialchars($update_info['rel']) . ").\n";
		       } elseif ($update_info['type'] == 'UPDATER') {
			    echo "Updating now would install updater version " .
				 htmlspecialchars($update_info['ver']) .
				 " (build " . htmlspecialchars($update_info['rel']) .
				 "), which is required to " .
				 "perform other updates.\n";
		       } else {
			    echo "Update would only install some minor components.\n";
		       }
		       echo "<br/>\n";
		       echo "Information about new firmware releases is available at<br/>\n";
		       echo "$linkfirmware.</p>\n";
		  }
	     }
	}else{
		unset($_POST['checkupdate']);
	}
}
if ( isset($_POST['doupdate']) ) {
	echo "<h2>Updating</h2>";
	echo "This operation might take some time. <br/>\n";
	echo "The $product will restart automatically at the end of the update process. <br/>\n";
	echo "<strong>Do not un-plug the device during the update.</strong><br/>\n";

	ob_flush();flush();
	
	$cmd='/usr/sbin/updater --log-to-stderr --lock-timeout=-1';
	
	if ($_POST['source']=='default') $cmd .=' --max-wait-time=-1';
	else $cmd .=' --repo=local-usb';
	//$cmd .= ' -N'; // FOR DEBUG
	
	$fd_desc = array(
	     0 => array("file", "/dev/null", "r"), // no stdin
	     1 => array("pipe", "w"), // read from stdout
	     2 => array("file", "/dev/null", "w"), // discard stderr
	     );

	$updater_proc = proc_open('exec '.$cmd.' 2>&1', $fd_desc, $updater_pipes);

	if (is_resource($updater_proc)) {
	     echo "<h3>Update log</h3>\n";
	     echo "<div class='logs'>\n";
	     while(!feof($updater_pipes[1])) {
		  $line = fgets($updater_pipes[1]);
		  checkUpdateInfo($line);
		  echo htmlentities($line)."<br/>\n";
		  ob_flush();flush();
	     }
	     echo "</div>\n";
	     fclose($updater_pipes[1]);
	     $status = proc_close($updater_proc);
	}
	if ($status==0) {
	     echo "<p>";
	     if ($update_info['type'] == 'FIRMWARE') {
		  echo "Installed firmware version " . htmlspecialchars($update_info['ver']) .
		       " (build " . htmlspecialchars($update_info['rel']) . ").\n";
	     } elseif ($update_info['type'] == 'UPDATER') {
		  echo "Installed updater version " . htmlspecialchars($update_info['ver']) .
		       " (build " . htmlspecialchars($update_info['rel']) .
		       "), which is required to " .
		       "perform other updates.\n";
	     } else {
		  echo "Installed some minor components.\n";
	     }
	     if ($updater_fallback) {
		  echo "<br/>\n";
		  echo "Other updates are still awaiting installation, please check ".
		       "for updates again and perform an update if any are proposed ".
		       "in order to have an up to date firmware.\n";
	     }
	     echo "</p>";
	}
}

if (isset($_POST['checkupdate']) || isset($_POST['doupdate'])){
	if ($status==1)
	     echo "Update failed.<br/><br/>\n";
	elseif ($status==2)
	     echo "<strong>Fatal error during update.</strong>. Update failed, the $product might not be usable anymore. It is recomended to contact support (<a href='mailto:$email' >$email</a>) and reinstall the firmware from a firmare image package in diagnostic mode.<br/>Please reboot in diagnostic mode to proceed with reinstallation.<br/><br/>";
	elseif ($status!=0)
	     echo "Failed starting update process.<br/><br/>\n";
	
	echo "<form action='update.php' method='post' >\n";
	if ($status!=0){
		echo "<input type='submit' value='Cancel' name='reload'/>\n";
	
	}else if ($nbUpdates){
	     echo "<input type='hidden' value=\"". htmlspecialchars($_POST['source'])."\" name='source'/>\n";
		echo "<input type='submit' value='Update Now' name='doupdate'/>\n";
		echo "<input type='submit' value='Cancel' name='reload'/><br/><br/>\n";
		echo "The $product will restart automatically at the end of the update process. <br/>\n";
		echo "<strong>Do not un-plug the device during the update</strong><br/><br/>";
	}else if ($updater_fallback){
	     echo "<input type='hidden' value=\"". htmlspecialchars($_POST['source'])."\" name='source'/>\n";
		echo "<input type='submit' value='Check for Updates' name='checkupdate'/>\n";
		echo "<input type='submit' value='Cancel' name='reload'/><br/><br/>\n";
		echo "<p>Information about new firmware releases is available at<br/>\n";
		echo "$linkfirmware.</p>\n";
	}else{
		echo "<input type='submit' value='OK' name='reload'/><br/><br/>\n";
		echo "<p>Information about new firmware releases is available at<br/>\n";
		echo "$linkfirmware.</p>\n";
	}
	echo "</form><br/>\n";
} else {
?>

<script type="text/javascript">
<!--
function autoUpdate()
{
	var checkUpdateAr=document.getElementById("AutoUpdateCheck");
	var selectUpdate=document.getElementById("AutoUpdateTime");
	selectUpdate.disabled=!checkUpdateAr.checked;
}


-->
</script>

<?php 
if (!isset($tabIdx) || $tabIdx==1) { // normal  
?>
<h2>Current Versions: </h2>
<table>
<?php

$output=array();
exec("rpm -q --queryformat '%{VERSION}\n%{RELEASE}\n' $releasepkg updater",$output);
if (count($output)==4 ){
     print("<tr><td>Firmware: </td><td>" .htmlspecialchars($output[0])."</td><td>(build ".
	   htmlspecialchars($output[1]). ")</td></tr>\n");
     print("<tr><td>Updater: </td><td>". htmlspecialchars($output[2])."</td><td>(build ".
	   htmlspecialchars($output[3]). ")</td></tr>\n");
} else {
	print("<tr><td>Firmware error: please contact <a href='mailto:$email' >$email</a></td></tr>\n");
}
?>
</table>
<p>Information about new firmware releases is available at<br/>
<?php echo $linkfirmware; ?>
</p>


<h2>Update Server</h2>
<form action="update.php" method="post" >
<br/>
Server URI: <input size='70' type='text' name='updater' value="<?php echo htmlspecialchars($updateuri); ?>"/><br/><br/>
<input type="submit" value="Apply" name="updateuri"/> <input type="submit" value="Reset to Default" name="reset"/>
</form>
<br/>
<h2>Automatic Update</h2>
<form action="update.php" method="post" >
<br/>
<?php

$disabledUpdateTime="";
print ("<input type='checkbox' id='AutoUpdateCheck' onclick='autoUpdate()' name='autoupdate'");
if ($time!=-1){
	 print ("checked='checked' />");
}else{
	print ("/>");
	$disabledUpdateTime="disabled='disabled' ";
}
echo "Enable automatic updates<br/><br/>\n";
echo "Update time: <select id='AutoUpdateTime' name='time' $disabledUpdateTime>";
for ($i=0; $i<24; $i++) {
	echo "<option value='$i'"; 
	if ($i==$time) echo " selected='selected'";
	echo ">$i:00</option>\n";	
}
?>
</select> <br/><br/>
<input type="submit" value="Apply" name="updateauto"/>
</form>
<br/>
<h2>Manual Update</h2>
<form action="update.php" method="post" >
<br/>
Update source : 
<select id='ManualUpdateSource' name='source'>
<option value='default'>From server</option>
<option value='usb'>From USB key</option>
</select>

<input type="submit" value="Check for Updates" name="checkupdate"/> 
</form>
<br/>
<?php

echo "<h2>Updater Info</h2>";

$statusFileName='/var/lib/updater/status';
$logFileName='/var/log/updater/lastlog';
$statusStr=array('READY'=>"Updater ready for updates",
				 'DELAYING'=>"Waiting for download",
				 'ANALYZING'=>"Analyzing system and repository for updates",
				 'DOWNLOADING'=>"Downloading packages to be updated / installed",
				 'TESTING'=>"Testing package install",
				 'UPDATING'=>"Updating / installing packages",
				 'PKGSDONE'=>"Finished updating / testing the packages",
				 'CORRUPTED'=>"Previous run was interrupted while updating / installing packages; System is most probably corrupted",
				 'REBOOTING'=>"Finished updating, device is rebooting",
				 );
$status=trim(file_get_contents($statusFileName));
if ($status=="") $status='READY';

echo "<h3>Current status: </h3>".$statusStr[$status]."<br/><br/>";
if ($status!='READY'){
	echo "<br/><form action='update.php' method='post' >To update the status, press the reload button of your browser, or ";
	echo "<input type='submit' value='Reload now' /></form><br/>";
}
$status=file_get_contents($logFileName);
if ($status!=""){
	echo "<h3>Last update log (".date ( "F d Y H:i:s", filemtime($logFileName))." ):</h3>\n<div class='logs'>\n";
	$lines=split("\n",$status);
	foreach ($lines as $line){
		echo htmlentities($line)."<br/>\n";
	}
	echo "</div>\n";
}

}

if ( ( isset($tabIdx) && $tabIdx==2 ) || !isset($licenses["HMP"]) || $licenses["HMP"]==false ) { // tab2
	echo "<h2>Licenses Info</h2>";
	echo "<table>\n";
	$featuremap = array("HMP"=>"Player", "INTER"=>"Interactivity", "MULTI"=>"Multiscreen", "P"=>"HW-Player");
	$featureignore = array("A", "G", "H", "P" );
	foreach ($licenses as $lic=>$val) {
		if ( !$advancedMode && isset($featureignore[trim($lic)]) )
			continue;
		if ( isset($featuremap[trim($lic)]) )
			$lic = $featuremap[trim($lic)];
		
		echo "<tr><td>$lic</td><td>";
		if ( isset($val['source']) )
			echo $val['source']." license. ";
		echo "</td><td>";
		if ($val===false) echo "Not valid.";
		else {
			if ( isset($val['exp]']) && $val['expire']!='never')
				echo "Valid, will expire in ".date("j M Y.", $val['expire']);
			else
				echo "Valid, no expiration date.";
		}
				
		echo "</td></tr>";
	}
	echo "</table>\n";
	
	echo "<h2>Update Licenses</h2><br/>";
	if ( isset($registration) ) { 
		echo "<form action='update.php' method='post' enctype='multipart/form-data' >\n";
		echo "<p>To add new licenses to the player, please enter your license key below. ";
		echo "The $player must have access to the internet to be able to validate the license key.</p>";
		echo "License key: ";
		echo "<input size='40' type='text' name='license_key' value=''/><br/>";
		echo "<input type='submit' value='Add license key' name='license_add'/><br/><br/>";
	}
	
	echo "<p>If the $player is not connected to the internet, you can use the manual registration procedure and upload the license file using the option below</p>";
	echo "<input size='40' type='file' name='new_license_file' /><br/>";
	echo "<input type='submit' value='Upload license file' name='license_file'/><br/><br/>";
	
	if ( isset($registration) ) {
		echo "<p>If you have already registered some license key for this player, you can retrieve them from the server using the following button.</p>";
		echo "<input type='submit' value='Update licenses' name='license_get'/><br/><br/>";
	}
	if ( file_exists("/etc/spinetix/licenses") ) {
		echo "<p>To clear all installed licenses, press the button below. Note that this will only remove the license from the player and not from the server.</p>";
		echo "<input type='submit' value='Clear licenses' name='license_clear'/><br/>";
	}
	echo "<input type='hidden' value='2' name='tabs'/>";
	echo "</form>\n";
	
} // tabs

} // check

} // reboot
include ("final.php");
?>
